
package net.javainthebox.flickr;

import javafx.ext.swing.SwingList;
import javafx.ext.swing.SwingListItem;
import javafx.ext.swing.SwingScrollPane;
import javafx.scene.Scene;
import javafx.stage.Stage;

// Xgŕ\鍀
var items: SwingListItem[];

var rssReader = AtomReader {
    url: "http://api.flickr.com/services/feeds/photos_public.gne?id=57085156@N00&lang=en-us&format=atom"
    
    onDone: function(infos: PhotoInfo[]) {
        // p[XIAHTMLŃXg̍ڂ\
        for (info in infos) {
            var item = SwingListItem {
                text: "<html><p>{info.title}</p><img src='{info.thumbnailUrl}' /></html>"
            }
            insert item into items;
        }
    }
}
rssReader.read();

Stage {
    title: "FlickrAtomReader"
    scene: Scene {
        width: 400
        height: 600
        content: [
            // XgXN[yCŕ\
            SwingScrollPane {
                width: 400
                height: 600
                
                view: SwingList {
                    items: bind items
                }
            }
        ]
    }
}