
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import javafx.io.http.HttpRequest;
import javafx.stage.Stage;
import javafx.scene.Scene;

var charset: String;
var request: HttpRequest;

request = HttpRequest {
    location: "http://gihyo.jp/dev/serial/01/javafx"

    onResponseHeaders: function(headerNames: String[]) {
        // HTTPwb_ content-type 當R[h擾
        var contentType = request.getResponseHeaderValue("content-type");
        var index = contentType.indexOf("=");
        charset = contentType.substring(index+1);
    }

    onInput: function(stream: InputStream) {
        // Zbgw肵ă[_𐶐
        var reader = new BufferedReader(
            new InputStreamReader(stream, charset));

        while(true) {
            var text = reader.readLine();
            if (text == null) {
                break;
            }
            println(text);
        }

        stream.close();
    }
}

request.enqueue();

Stage {
    title: "Dummy"
    scene: Scene {
        width: 200
        height: 200
        content: [  ]
    }
}