
import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.scene.Scene;
import javafx.scene.paint.Color;
import javafx.scene.paint.RadialGradient;
import javafx.scene.paint.Stop;
import javafx.scene.shape.Circle;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javafx.stage.Stage;

import java.lang.Object;
import java.util.Date;

// 񓯊̌ʂێϐ
var result: Date = new Date();

// 񓯊5bƂɍs^CC
Timeline {
    repeatCount: Timeline.INDEFINITE
    autoReverse: true
    keyFrames: [
        KeyFrame {
            time: 0s
            action: function() {
            	// 񓯊NX𐶐A񓯊Jn
                var task: LongLongTask;
                task = LongLongTask {
                    // 񓯊ɃR[֐
                    onDone: function(flag: Boolean) : Void {
                        result = task.result;
                    }
                }
            }
        },
        KeyFrame {
            time: 5s
        }
    ]
}.play();

// {[
var ball = Circle {
    centerX: 0
    centerY: 0
    radius: 20
    fill: RadialGradient {
        centerX: 0.25
        centerY: 0.25
        stops: [
            Stop {
                offset: 0.0
                color: Color.WHITE
            },
            Stop {
                offset: 0.6
                color: Color.RED
            }
        ]
    }
}

// {[̐̃Aj[V
Timeline {
    repeatCount: Timeline.INDEFINITE
    autoReverse: true
    keyFrames: [
        KeyFrame {
            time: 0s
            values: ball.translateX => 20.0
        },
        KeyFrame {
            time: 2s
            values: ball.translateX => 280.0
        },
    ]
}.play();

// {[̐̃Aj[V
Timeline {
    repeatCount: Timeline.INDEFINITE
    autoReverse: true
    keyFrames: [
        KeyFrame {
            time: 0s
            values: ball.translateY => 20.0
        },
        KeyFrame {
            time: 1.3s
            values: ball.translateY => 180.0
        },
    ]
}.play();

Stage {
    title: "Long Long Task"
    scene: Scene {
        width: 300
        height: 200
        content: [ 
            ball,
            Text {
                font : Font {
                    size: 20
                }
                x: 10,
                y: 100
                content: bind "{result}"
            }
        ]
    }
}