
import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.ext.swing.SwingButton;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;

import java.awt.image.BufferedImage;

// F̃CfbNX
var colors: Integer[] = for(i in [0..7]) {
    for (blue in [0, 0x66, 0xff], green in [0, 0x66, 0xff], red in [0, 0x66,0xff]) {
        var color = (0xff - red) * 0x10000 + (0xff - green) * 0x100 + (0xff - blue);
    }
}

// ImageNX̓sNZɃANZXłȂ̂ŁABufferedImageNXgp
var bufferedImage: BufferedImage;
var image: Image;
// 񓯊Ń}fǔvZsNX
var mandelbrot: Mandelbrot;

// 񓯊ōs鏈猋ʂ󂯎邽߂̃^CC
var timeline: Timeline;
timeline = Timeline {
    repeatCount: Timeline.INDEFINITE
    keyFrames: [
        KeyFrame {
            time: 0.0s
            action: function() {
                while(true) {
                    // L[vZʂ̎o
                    var point = mandelbrot.poll();
                    if (point != null) {
                        // vZʂC[WɐFZbg
                        var x = (point.x * 200 + 400) as Integer;
                        var y = (point.y * 200 + 240) as Integer;
                        var color = colors[point.number];
                        bufferedImage.setRGB(x, y, color);
                    } else {
                        // L[ł΁A0.1b҂
                        break;
                    }
                }
                // BufferedImageImageIuWFNg𐶐
                image = Image.fromBufferedImage(bufferedImage);
            }
        },
        KeyFrame {
            time: 0.1s
            action: function() {
                // 񓯊IĂAtimelineXgbv
                if (mandelbrot.done) {
                    timeline.stop();
                }
            }
        }
    ]
}

Stage {
    title: "Mandelbrot"
    scene: Scene {
        width: 520
        height: 480
        fill: Color.BLACK
        content: [
            ImageView {
                image: bind image
            },
            SwingButton {
                text: "DRAW"
                action: function() {
                    timeline.stop();
                    if (mandelbrot != null) {
                        // 񓯊ŏsĂꍇ̓LZ
                        mandelbrot.cancel();
                    }

                    // C[WMandelbrotIuWFNgVɐA
                    // 񓯊Jn
                    bufferedImage = new BufferedImage(520, 480, BufferedImage.TYPE_INT_RGB);
                    mandelbrot = Mandelbrot {};
                    timeline.play();
                }
            }
        ]
    }
}
