
import java.util.concurrent.BlockingQueue;

import com.sun.javafx.runtime.async.AbstractAsyncOperation;
import com.sun.javafx.runtime.async.AsyncOperationListener;

public class MandelbrotWorker extends AbstractAsyncOperation<Object> {
    // CxgfBXpb`XbhƋLL[
    // XbhZ[tBlockingQueueC^tF[Xgp
    private BlockingQueue<Point> queue;
    
    public MandelbrotWorker(BlockingQueue<Point> queue, AsyncOperationListener<Object> listener) {
        super(listener);
        
        // CxgfBXpb`XbhƃL[L
        this.queue = queue;
    }

    // 񓯊ɍs
    @Override
    public Object call() throws InterruptedException {
        for (double x = -2.0; x <= 0.6; x += 0.005) {
            for (double y = -1.2; y <= 1.2; y += 0.005) {
                Point c = new Point(x, y, 0);
                Point z = new Point(0.0, 0.0, 0);

                while (true) {
                    // Q̌vZ
                    z = calcNextPoint(z, c);

                    // z̑傫100,000ȏłΖƌȂ
                    // ܂A215ȏ̃Ce[VJԂĂ
                    // 100,000ȏɂȂȂ΃}fuWɑĂƌȂ
                    if (z.length() > 100000 || z.number > 215) {
                        break;
                    }
                }
                // Ce[VRs[
                c.number = z.number;

                // vZʂL[ɓ
                queue.put(c);
            }
        }
 
        return null;
    }

    // }fȗQ
    private Point calcNextPoint(Point z, Point c) {
        double x = z.x * z.x - z.y * z.y + c.x;
        double y = 2 * z.x * z.y + c.y;
 
        return new Point(x, y, z.number + 1);
    }
}
